]> git.pld-linux.org Git - packages/ntp.git/blobdiff - ntp.init
- rel 2
[packages/ntp.git] / ntp.init
index 9bdd17bb142fa900d9b12bfdff6076e19f6b0ac8..b569e6f445004bf68ebf458c0560fe32f326502e 100644 (file)
--- a/ntp.init
+++ b/ntp.init
@@ -1,60 +1,93 @@
 #!/bin/sh
 #
-# ntp           This shell script takes care of starting and stopping
-#               ntp (NTP daemon).
+# ntpd         This shell script takes care of starting and stopping
+#              ntp (NTP daemon).
 #
 # chkconfig:   2345 55 10
-# description: ntp is the NTP daemon.
+# description: ntpd is the NTP daemon.
 
 # Source function library.
 . /etc/rc.d/init.d/functions
 
+upstart_controlled
+
 # Source networking configuration.
 . /etc/sysconfig/network
 
+# Source ntp configuration
+. /etc/sysconfig/ntpd
+
 # Check that networking is up.
-[ "${NETWORKING}" = "no" ] && exit 0
+if is_yes "${NETWORKING}"; then
+       if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
+               msg_network_down "ntpd"
+               exit 1
+       fi
+else
+       exit 0
+fi
 
-[ -x /usr/sbin/ntpd -a -f /etc/ntp/ntp.conf ] || exit 0
+[ -f /etc/ntp/ntp.conf ] || exit 0
 
-# See how we were called.
-case "$1" in
-  start)
+start() {
        # Check if the service is already running?
-        if [ ! -f /var/lock/subsys/ntp ]; then
-               if is_yes "$SYNC_TIME"; then
-                       # Adjust time to make life easy for ntp
-                               run_cmd "Syncing time for ntp" /usr/sbin/ntpdate $NTPDATE_OPTIONS $NTPDATE_SERVERS
-               fi
-               msg_starting ntp
-               daemon ntpd -c /etc/ntp/ntp.conf
-               RETVAL=$?
-               [ $RETVAL -eq 0 ] && touch /var/lock/subsys/ntp
-        else
-               msg_Already_Running ntp
-               exit 1
+       if [ ! -f /var/lock/subsys/ntpd ]; then
+               msg_starting "ntpd"
+               daemon /usr/sbin/ntpd -c /etc/ntp/ntp.conf -p /var/run/ntpd.pid -u ntp:ntp $NTPD_OPTIONS
+               RETVAL=$?
+               [ $RETVAL -eq 0 ] && touch /var/lock/subsys/ntpd
+       else
+               msg_already_running "ntpd"
        fi
-        ;;
-  stop)
-       if [ -f /var/lock/subsys/ntp ]; then
-               msg_stopping ntp
+}
+
+stop() {
+       if [ -f /var/lock/subsys/ntpd ]; then
+               msg_stopping "ntpd"
                killproc ntpd
-               rm -f /var/lock/subsys/ntp
-        else
-               msg_Not_Running ntp
-               exit 1
+               rm -f /var/lock/subsys/ntpd
+       else
+               msg_not_running "ntpd"
        fi
+}
+
+condrestart() {
+       if [ -f /var/lock/subsys/ntpd ]; then
+               stop
+               start
+       else
+               msg_not_running "ntpd"
+               RETVAL=$1
+       fi
+}
+
+RETVAL=0
+# See how we were called.
+case "$1" in
+  start)
+       start
+       ;;
+  stop)
+       stop
+       ;;
+  restart)
+       stop
+       start
+       ;;
+  # NB! don't remove 'condrestart': dhcpcd calls this
+  try-restart|condrestart)
+       condrestart 0
+       ;;
+  force-reload)
+       condrestart 7
        ;;
   status)
        status ntpd
-       ;;
-  restart|reload)
-       $0 stop
-       $0 start
+       exit $?
        ;;
   *)
-        echo "Usage: $0 {start|stop|restart|status}"
-        exit 1
+       msg_usage "$0 {start|stop|restart|try-restart|force-reload|condrestart|status}"
+       exit 3
 esac
 
-exit 0
+exit $RETVAL
This page took 0.558701 seconds and 4 git commands to generate.